﻿Imports Xceed.Wpf.Toolkit

Namespace RtbFormatter
    Public Class MySpecialFormatter
        Implements ITextFormatter

        Public Sub SetText(document As FlowDocument, text As String) Implements ITextFormatter.SetText
            Dim textParts = text.Split("{"c,
                                       "}"c)
            Dim writeBold As Boolean = False
            Dim writeColor As Color = Colors.Black
            document.Blocks.Clear()

            Dim p As New Paragraph()
            document.Blocks.Add(p)

            For Each tp In textParts
                Select Case tp
                    Case "tp"
						writeColor = Colors.Violet

						Dim uiBlock As New InlineUIContainer()
						Dim vb As New Viewbox() With {.Height = 25, .Width = 25, .VerticalAlignment = VerticalAlignment.Bottom}
						vb.Child = New uclTs() With {.Angle = 0, .Foreground = New SolidColorBrush(writeColor), .Text = "TP"}
						uiBlock.Child = vb
						p.Inlines.Add(uiBlock)
						writeColor = Colors.Black
					Case "ts"
						writeBold = True
                        writeColor = Colors.Red
                    Case "\tp"
						writeColor = Colors.Violet

						Dim uiBlock As New InlineUIContainer()
						Dim vb As New Viewbox() With {.Height = 25, .Width = 25, .VerticalAlignment = VerticalAlignment.Bottom}
						vb.Child = New uclTs() With {.Angle = 180, .Foreground = New SolidColorBrush(writeColor), .Text = "TP"}
						uiBlock.Child = vb
						p.Inlines.Add(uiBlock)
						writeColor = Colors.Black
					Case "\ts"
						writeBold = False
                        writeColor = Colors.Black
                    Case Else

                        Dim r As New Run(tp)
                        r.FontWeight = If(writeBold, FontWeight.FromOpenTypeWeight(800), FontWeight.FromOpenTypeWeight(500))
                        r.Foreground = New SolidColorBrush(writeColor)

                        p.Inlines.Add(r)
                End Select
            Next

        End Sub

        Public Function GetText(document As FlowDocument) As String Implements ITextFormatter.GetText
            Dim doc = document
            Dim text As String = ""

            For Each b As Paragraph In doc.Blocks.ToList
                For Each inline As Run In b.Inlines.ToList
                    text += inline.Text
                Next
            Next

            Return text
        End Function
    End Class
End Namespace
