﻿Imports Xceed.Wpf.Toolkit

Namespace RtbFormatter
    Public Class MySpecialIconFormatter
        Implements ITextFormatter

        Public Sub SetText(document As FlowDocument, text As String) Implements ITextFormatter.SetText
            Dim textParts = text.Split("{"c,
                                       "}"c)

            Dim writeColor As Color = Colors.Black
            document.Blocks.Clear()

            Dim p As New Paragraph()
            document.Blocks.Add(p)

            For Each tp In textParts
                Select Case tp
                    Case "tp"
                        writeColor = Colors.Violet

                        Dim uiBlock As New InlineUIContainer()
                        Dim vb As New Viewbox() With {.Height = 25, .Width = 25, .VerticalAlignment = VerticalAlignment.Bottom}
                        vb.Child = New uclTs() With {.Angle = 0, .Foreground = New SolidColorBrush(writeColor), .Text = "TP"}
                        uiBlock.Child = vb
                        p.Inlines.Add(uiBlock)
                    Case "ts"
                        writeColor = Colors.Red

                        Dim uiBlock As New InlineUIContainer()
                        Dim vb As New Viewbox() With {.Height = 25, .Width = 25, .VerticalAlignment = VerticalAlignment.Bottom}
                        vb.Child = New uclTs() With {.Angle = 0, .Foreground = New SolidColorBrush(writeColor), .Text = "TS"}
                        uiBlock.Child = vb
                        p.Inlines.Add(uiBlock)
                    Case "\tp"
                        writeColor = Colors.Violet

                        Dim uiBlock As New InlineUIContainer()
                        Dim vb As New Viewbox() With {.Height = 25, .Width = 25, .VerticalAlignment = VerticalAlignment.Bottom}
                        vb.Child = New uclTs() With {.Angle = 180, .Foreground = New SolidColorBrush(writeColor), .Text = "TP"}
                        uiBlock.Child = vb
                        p.Inlines.Add(uiBlock)
                    Case "\ts"
                        writeColor = Colors.Red

                        Dim uiBlock As New InlineUIContainer()
                        Dim vb As New Viewbox() With {.Height = 25, .Width = 25, .VerticalAlignment = VerticalAlignment.Bottom}
                        vb.Child = New uclTs() With {.Angle = 180, .Foreground = New SolidColorBrush(writeColor), .Text = "TS"}
                        uiBlock.Child = vb
                        p.Inlines.Add(uiBlock)
                    Case Else

                        Dim r As New Run(tp)
                        r.FontWeight = FontWeight.FromOpenTypeWeight(500)
                        r.Foreground = New SolidColorBrush(Colors.Black)

                        p.Inlines.Add(r)
                End Select
            Next

        End Sub

        Public Function GetText(document As FlowDocument) As String Implements ITextFormatter.GetText

        End Function
    End Class
End Namespace
